# Measure the time it takes to execute the file
start_time_AQMS <- Sys.time()

# Loop Ordinary Kriging #######################################################

print("Loop Ordinary Kriging")

save_OK_result              <- paste0(save_result,"OK_monthly_",pollutant, "_",read_year)
model_raw_at_AQMS           <- matrix(NA,ncol=nrow(local_stations@data),nrow=0) #list(length=nrow(date_times)) #we will have a large list with a data.frame for each hour
colnames(model_raw_at_AQMS) <- local_stations$ref_obs #we want a matrix with empty data and the name of stations


for(i in 1:length(available_dates_model)){
  # i <- 4
  date_i <- available_dates_model[i]
  
  if(i!=length(available_dates_model)){
    date_ii <- available_dates_model[i+1]
  }else{
    date_ii <- date_i
  }
  print(date_i)

#TODO!!!! FIX: if resolution is hourly we are only taking the first hour of the day
  # we need to loop through the hours in the day
  
# for (hour in 1:length_loop) {
  # hour <- 1
  # print(paste0("loop OK number:",hour))
  # df_model <- model[,,hour]
  df_model <- model[,,i]
  
  #if all the model for a certain hour is nan we cannot apply UK
  if (!any(is.na(df_model))){
    
    # 1. Interpolate model values at obs locations
    #    1.1. Set spatialpointsdataframe
    #raw model:
    df_model                  <- data.frame(lat=lat_model,lon=lon_model,pollutant=sapply(df_model,as.matrix))
    coordinates(df_model)     <- ~lon+lat
    sp::proj4string(df_model) <- crs_latlon
    
    #config the coordinates in UTM
    if (compute_in_UTM) {
      df_model <- spTransform(df_model, sp::CRS(crs_utm))
    }
    
    #observations:
    df_obs                   <- data.frame(lat=local_stations@coords[,2],lon=local_stations@coords[,1],pollutant=NA,code=local_stations$ref_obs)
    coordinates(df_obs)      <- ~lon+lat
    sp::proj4string(df_obs)  <- crs_latlon
    
    #config the coordinates in UTM
    if (compute_in_UTM) {
      df_obs <- spTransform(df_obs, sp::CRS(crs_utm))
    }
    
    #if(any(is.na(df_obs@data)) | isTRUE(df_obs@data$pollutant<0)){
     # df_obs$pollutant<- ifelse(is.na(df_obs$pollutant)|df_obs$pollutant<0,0,df_obs$pollutant)
      #print(paste0("Negative or NA in the observations has been substituted by zero in the hour:", " ", hour))
    #}
    
    #    1.2 Compute Variogram
    set.seed(1) #we are picking random points in the next line, set.seed permits us to have same points in each loop
    pick_random_points        <- sample(1:nrow(df_model),1000)

    pollutant.fit_ok          <- automap::autofitVariogram(formula=pollutant~1, 
                                                           input_data=df_model[pick_random_points,],
                                                           fix.values=c(0,NA,NA)) #nugget,range,sill
    # Hem posat model='Ste' pk la segona hora del 01/06/2021 peta el variograma, mirar bé perque no s'ajusa
    
    #Save the first variogram executed for a certain pollutant if we already don't have one saved:
     if (!file.exists(variogram_ok)) {
       saveRDS(pollutant.fit_ok,variogram_ok)
     }
    #    1.3 Compute ordinary Kriging
    
    #Del model interpolo cap a les coordenades de les obs 'OK'
    ok_gstat <- gstat(formula=pollutant~1, data = df_model, model = pollutant.fit_ok$var_model, nmax=100)
    
    #Interpolacio del model a les coordenades del conjunt
    OK       <- predict(object=ok_gstat, newdata=df_obs)
    
    # forcing concentrations to be positive
    OK[OK<0] <- 0
    
    #If the variogram has singular matrix then it produces NAN's, so in that case we take a good Variogram instead:
    if(any(is.na(OK@data$var1.pred))){
      print("WARNING: VARIOGRAM DIVERGED! Using a precalculated VARIOGRAM")
      pollutant.fit_ok=readRDS(variogram_ok)
      ok_gstat <- gstat(formula=pollutant~1, data = df_model, model = pollutant.fit_ok$var_model, nmax=100)
      
      #Interpolacio del model a les coordenades del conjunt
      OK <-predict(object=ok_gstat, newdata=df_obs)
    }
    
    model_raw_at_AQMS_h           <- matrix(data=OK$var1.pred, nrow=1)
    colnames(model_raw_at_AQMS_h) <- df_obs$code
    
    model_raw_at_AQMS <-  plyr::rbind.fill(as.data.frame(model_raw_at_AQMS), as.data.frame(model_raw_at_AQMS_h))
    

    
  } else{
    print(paste0("WARNING: The model is corrupted or non-existent in ", date_i))
    model_raw_at_AQMS_h           <- matrix(data=NA, nrow=1,ncol=nrow(local_stations@data))
    colnames(model_raw_at_AQMS_h) <- local_stations@data$ref_obs
    model_raw_at_AQMS             <- plyr::rbind.fill(as.data.frame(model_raw_at_AQMS),as.data.frame(model_raw_at_AQMS_h))
  }
  
  # Check if we need to save the OK (last day of each month)
  if (!file.exists(save_OK_result)) {
    # Si no existe, crear la carpeta
    dir.create(save_OK_result)
  }
  
  # month_num <- mes[hour]
  if(time_resolution=="hourly"){
    available_dates_model <- available_dates_model %>% 
      as.POSIXct("%Y%m%d %H:%M",tz="UTC")
    
    month_num <- date_i %>%
      as.Date("%Y%m%d %H:%M") %>%
      month()
    next_month_num <- date_ii %>%
      as.Date("%Y%m%d %H:%M") %>%
      month()
    # day_num <- date_i %>%
    #   as.Date("%Y%m%d %H:%M") %>%
    #   day()
  }else if(time_resolution=="daily"){
    available_dates_model <- available_dates_model %>% 
      as.Date("%Y%m%d",tz="UTC")
    
    month_num <- date_i %>%
      as.Date("%Y%m%d") %>%
      month()
    next_month_num <- date_ii %>%
      as.Date("%Y%m%d") %>%
      month()
    
    # day_num <- date_i %>%
    #   as.Date("%Y%m%d") %>%
    #   day()
  }
  
  
  # if the month of next date is different, save
  if(next_month_num != month_num | i==length(available_dates_model)){
    save(object=model_raw_at_AQMS, file= paste0(save_OK_result,"/model_raw_at_AQMS_", "month_", month_num, ".rds"))
  }
  
  # if ((month_num %in% c(4, 6, 9, 11) && day_num==30) ||
  #     (month_num == 2 && day_num==28) ||
  #     (month_num %in% c(1, 3, 5, 7, 8, 10, 12) && day_num==31)) {
  #   save(object=model_raw_at_AQMS, file= paste0(save_OK_result,"/model_raw_at_AQMS_", "month_", month_num, ".rds"))
  # }
  
}


model_raw_at_AQMS_df      <- cbind(date=available_dates_model, 
                                   as.data.frame(model_raw_at_AQMS))

# impose timezone UTC (it was assuming CET)
tz(model_raw_at_AQMS_df$date) <- "UTC"


if (save_OK){
  saveRDS(object=model_raw_at_AQMS_df, file=paste0(save_result,"model_raw_at_AQMS_",file_format, "_",pollutant,"_df.rds"))
  print("model_raw_at_AQMS saved")
} else {
  print("model_raw_at_AQMS have not been saved")
}


end_time_AQMS    <- Sys.time()
temps_total_AQMS <- end_time_AQMS - start_time_AQMS
print(paste0("Interpolation of the model to AQMS, execution time:",temps_total_AQMS))

